from shutil import copy
from os import mkdir
from os.path import exists

import sys
print "\nsys.path=" 
print sys.path

userName =  "%USER_NAME%"
passWord = "%PASS_WORD%" 
port = "%PORT%"
hostname = "%HOST_NAME%"
targetServer = "%ADMIN_SERVER%"
domainPath = "%DOMAIN_PATH%"
jmsDecriptorFile = "%JMS_DESCRIPTOR_FILE%"
subDeploymentNames = [ %SUB_DEPLOYMENT_NAME% ]

try:
	connect( userName, passWord, "t3://" + hostname + ":" + port )
except Exception, e:
	print e 
	dumpStack()

edit()
startEdit(60000, 120000 )
newSystemModuleName = "%JMS_MODULE_NAME%"

servermb=getMBean("Servers/" + targetServer )
if servermb is None:
	print '@@@ No server MBean found ' + targetServer
else:
	print 'Add to target server ' + targetServer


existingSystemModuleName = ""

#Search for the system module using default name implied by descriptor file name
jmsMySystemResourceList = find (  newSystemModuleName, "JMSSystemResource" )
if jmsMySystemResourceList.size() > 0 :
	modulePath = jmsMySystemResourceList[0].split('/')
	existingSystemModuleName = modulePath[2]
else:
	#try find a system module which has the same descriptor name
	cd ('/JMSSystemResources')
	descriptorPath = find( 'DescriptorFileName' )
	for path in descriptorPath:
		values = path.split()
		if values[2]=='jms/' + newSystemModuleName +'-jms.xml':
			modulePath = values[0].split('/')	   		
			print 'Found module: ' + modulePath[2]
			existingSystemModuleName = modulePath[2]
			break

if len( existingSystemModuleName ) > 0 :
	print 'Updating JMS System module ' + existingSystemModuleName
	cd ( '/JMSSystemResources/' + existingSystemModuleName )
	#Get a list of existing SubDeployments
	existingSubDeployments = []
	for sub in cmo.getSubDeployments():
		existingSubDeployments.append( sub.getName() )

	for name in subDeploymentNames:
		#Create the sub deployment only if not already existing on server
		if len(name) > 0 and name not in existingSubDeployments:
			print 'Creating new SubDeployment ' + name 
			cmo.createSubDeployment( name )
	
	cd ( 'JMSResource/' + existingSystemModuleName )
	#Touch the Notes attribute for the system module so that an XML is saved 
	#into domain/config/pending when we call save()
	notes = ''
	if cmo.getNotes() is not None:
		notes = cmo.getNotes()
	cmo.setNotes(notes)
else:
	print 'Creating ' + newSystemModuleName
	jmsMySystemResource = create (  newSystemModuleName, "JMSSystemResource" )
	print( jmsMySystemResource )
	
	jmsMySystemResource.addTarget(servermb)
	
	for name in subDeploymentNames:
		if len(name) > 0 :
			print 'Create SubDeployment ' + name 
			jmsMySystemResource.createSubDeployment( name )

	cd( newSystemModuleName )
	cd ( 'JMSResource/' + newSystemModuleName )
	#Touch the Notes attribute for the system module so that an XML is saved 
	#into domain/config/pending when we call save()
	notes = '' + newSystemModuleName
	cmo.setNotes(notes)

try:
	save()
except Exception, e:
	print e
	print '[ERROR]save JMS system module changes'
	dumpStack()

print "Copy JMS Descriptor from " + jmsDecriptorFile + " to target " + domainPath +  "/pending/jms" 

try:
	if exists(domainPath +  "/pending/jms" )== False :
		os.mkdir( domainPath +  "/pending/jms" )
except Exception, e:
	print e 
	dumpStack()
	print "Find " + domainPath +  "/pending/jms"

try:
	copy( jmsDecriptorFile, domainPath +  "/pending/jms");
	activate()
except Exception, e:
	print e 
	dumpStack()

#A simple workaround to make sure the WLS MBean edit tree (used by WLS Console)
#picks up the changes just activated
print 'Synchronizing WebLogic MBean edit tree'
startEdit(60000, 120000 )
undo('true', 'y')
stopEdit('y')
disconnect()